<?php
//Makes the second pass through the file, deciding what each line is
//
// The job of this parser is to:
// (a) Classify each line
// (b) Decide what to do with it
// (c) Determine where to go
// (d) Give up and let the user wire the rest.
// (e) Watch for line numbers... Maybe call them labels--that's what they are

define("VERBOSEP2L1", true);
define("VERBOSEP2L2", true);

function p2add($line,$type,$sub)
  {
  global $code_table_p2;
  $code_table_p2[$sub][$type][]=$line;
  }

function can_ignore($line)
  {
  // Are the lines drawing or similar lines that need manual handling?

  }

function p2parse($line)
  {
  //Determine what the line does.
  //Due to its length, this is saved in a different file.
  require "linetype.php";


  foreach($matchstr as $keyword => $type)
    {
    $m="/". $keyword ."/";
    if (1==preg_match($m, $line))
      {
      $type = $matchstr[$keyword];
      if (VERBOSEP2L2)
        {
        wg("[");
        wr("p2parse");
        wg("]");
        wbk(" Found match ");
        wb($keyword);
        wbk(" of type ");
        wb($type);
        wd();
        }
      stats_add($type);
      return $type;
      }
    }
  }

function pass2()
  {
  global $code_table;
  $index = array_keys($code_table);
  foreach ($index as $name)
    {
    $index2=array_keys($code_table[$name]);
    foreach ($index2 as $ref)
      {

      $line=$code_table[$name][$ref];
      $type = p2parse($line);
      p2add($line,$type,$name);
      }
    }
  }

function parsed_listing_p2()
  {
  global $code_table_p2;
  $index = array_keys($code_table_p2);
  foreach ($index as $name)
    {
    $index2=array_keys($code_table_p2[$name]);
    foreach ($index2 as $ref)
      {
      $index3=array_keys($code_table_p2[$name][$ref]);
      foreach ($index3 as $thisline)
        {
        $line=$code_table_p2[$name][$ref][$thisline];
        wbk("[");
        wg($name);
        wbk("] {");
        wg($ref);
        wbk("} ");
        wb($line);
        wd();
        }
      }
    wd();
    }
  }

// $code_table_p2[$sub][$type] = $line
$code_table_p2 = array();
?>